# Tutorials

Welcome to the exciting world of aiFlows! 🚀 These tutorials are your gateway to mastering the main concepts of aiFlows and the FlowVerse through hands-on examples. To make the most of your learning experience, **we recommend following the tutorials in the given order**. Each tutorial builds on the concepts introduced in the previous one, providing a structured and comprehensive learning path.

Get ready for an engaging journey where you'll build practical skills and gain a deeper understanding of the power and versatility of aiFlows.

Let's dive in and explore the following tutorials !

## [1. Setting up aiFlows](./setting_up_aiFlows.md)
#### By the Tutorial's End, I Will Have...
* Installed the aiFlows library successfully
* Established an organized file structure for seamless collaboration within the FlowVerse
* Set up a Hugging Face account for contribution to the FlowVerse (Optional)
* Configured and activated my API keys

## [2. Atomic Flow Tutorial](./atomic_flow.md)

#### By the Tutorial's End, I Will Have...

* Gained insight into the relationship among a Flow, an input interface, and an output interface
* Acquired hands-on experience in creating an `AtomicFlow` with the example of `ReverseNumberAtomic`
* Learned how to run a flow with a `FlowLauncher`

## [3. Composite Flow Tutorial](./composite_flow.md)
#### By the Tutorial's End, I Will Have...

* Gained insights into the concept of a Composite Flow
* Acquired the skills to create a `SequentialFlow` through a toy example
* Developed an understanding of the utility of input and output interfaces in connecting subflows within the flow structure

## [4. Introducing the FlowVerse with a Simple Q&A Flow](./intro_to_FlowVerse_minimalQA.md)

#### By the Tutorial's End, I Will Have...

* Gained an understanding of the FlowVerse and its significance
* Acquired the skills to retrieve flows from the FlowVerse
* Successfully developed my initial flow by incorporating a FlowVerse flow
* Created a Simple Q&A flow capable of managing user-assistant interactions with a Language Model (LLM) through an API
* Familiarized myself with the fundamental parameters of the `ChatAtomicFlow`

## [5. ReAct Tutorial](./reAct.md)

#### By the Tutorial's End, I Will Have...

* Gained an understanding of the ReAct flow and its significance
* Acquired the skills to pull multiple flows from the FlowVerse with external library dependencies
* Successfully developed my first personalized ReAct flow
* Familiarized myself with the essential parameters of the `ControllerExecutorFlow`

## [6. ReAct With Human Feedback Tutorial](./reActwHumanFeedback.md)

#### By the Tutorial's End, I Will Have...

* Recognized the distinctions between ReAct and ReActWithHumanFeedback and their consequences
* Learned how to integrate a human feedback flow into ReAct
* Incorporated customized functions into the input and output interfaces.
* Grasped the limitations of ReAct, particularly its lack of long-term memory
* Deepened my understanding of the key parameters in the `ControllerExecutorFlow` configuration


## [7. AutoGPT Tutorial](./autogpt_tutorial.md)

#### By the Tutorial's End, I Will Have...

* Acknowledged the differences between AutoGPT and ReActWithHumanFeedback and their implications
* Gained proficiency in executing the AutoGPTFlow
* Enhanced comprehension of intricate flow structures